/********
	    Packet filter by wallrich@loria.fr

	    how to display the packet

*********/


#include "nicedump.h"

/******* externs from outside *******/
extern int strncmp(const char *, const char *, size_t);

/*************************************/

/********
	    display in text
*******/
void display(params *parm, options opt) {
  int i,j;
  int have_to_display=NO;
  int len=0;
  
  /*** option -proto ***/
  if (opt.display_proto) {
    int disp=NO;

    len=strlen(opt.display_proto);
    for (i=0 ; i<parm->aff_last ; i++) {
	 if (parm->type_aff[i]==D_LABEL) {
	   j=strlen(parm->aff[i]);
	   if (strncmp(opt.display_proto,parm->aff[i],(len<j)?len:i)==0) {
	     disp=YES;
	   }
	 }      
    }
    if (disp==NO) return;
  }
  /*** ------------- ***/


  /*** option -dl ***/
  if (!opt.disp_label) 
    have_to_display=YES;
  else 
    len=strlen(opt.disp_label);
  /*** ---------- ***/

  /*** option -sum ***/
  if (opt.sum) {
    if (parm->sum) fprintf(opt.dest,"%s",parm->sum);
  }
  /*** ----------- ***/


  /* printing packet */  
  for (i=0 ; i<parm->aff_last ; i++) {
    if (have_to_display) {
	 switch (parm->type_aff[i]) {
	 case D_WARNING:
	   fprintf(opt.dest,"\n");
	   for (j=0;j<parm->indenttab[i];j++) fprintf(opt.dest,"     ");
	   fprintf(opt.dest,"Warning : %s",parm->aff[i]);
	   break;
	 case D_DEBUG:
	   fprintf(opt.dest,"\n");
	   for (j=0;j<parm->indenttab[i];j++) fprintf(opt.dest,"     ");
	   fprintf(opt.dest,"Debug : %s",parm->aff[i]);
	   break;
	 case D_INFO:
	   fprintf(opt.dest,"\n");
	   for (j=0;j<parm->indenttab[i];j++) fprintf(opt.dest,"     ");
	   fprintf(opt.dest,"Info : %s",parm->aff[i]);
	   break;
	 case DE_SYNTAX:
	   fprintf(opt.dest,"\n");
	   for (j=0;j<parm->indenttab[i];j++) fprintf(opt.dest,"     ");
	   fprintf(opt.dest,"Syntax Error : %s",parm->aff[i]);
	   break;
	 case DE_CALC:
	   fprintf(opt.dest,"\n");
	   for (j=0;j<parm->indenttab[i];j++) fprintf(opt.dest,"     ");
	   fprintf(opt.dest,"Calcul error : %s",parm->aff[i]);
	   break;
	 case DE_PROTO:
	   fprintf(opt.dest,"\n");
	   for (j=0;j<parm->indenttab[i];j++) fprintf(opt.dest,"     ");
	   fprintf(opt.dest,"Protocol error : %s",parm->aff[i]);
	   break;
	 case DE_DEVICE:
	   fprintf(opt.dest,"\n");
	   for (j=0;j<parm->indenttab[i];j++) fprintf(opt.dest,"     ");
	   fprintf(opt.dest,"Device error : %s",parm->aff[i]);
	   break;
	 case DE_MEMORY:
	   fprintf(opt.dest,"\n");
	   for (j=0;j<parm->indenttab[i];j++) fprintf(opt.dest,"     ");
	   fprintf(opt.dest,"Memory error : %s",parm->aff[i]);
	   break;
	 case D_VALUE:
	   fprintf(opt.dest,"\n");
	   for (j=0;j<parm->indenttab[i];j++) fprintf(opt.dest,"     ");
	   fprintf(opt.dest,"|%s",parm->aff[i]);
	   break;
	 case D_LABEL:
	   fprintf(opt.dest,"\n");
	   for (j=0;j<parm->indenttab[i]-1;j++) fprintf(opt.dest,"     ");
	   if ((i>0) && (parm->indenttab[i]>parm->indenttab[i-1])) fprintf(opt.dest,"+----");
	   if ((i>0) && (parm->indenttab[i]==parm->indenttab[i-1])) fprintf(opt.dest,"     ");
	   fprintf(opt.dest,"+-- %s --",parm->aff[i]);
	   break;
	 case D_REST:
	   if (opt.display_rest==NO) break;
	   fprintf(opt.dest,"\n");
	   for (j=0;j<parm->indenttab[i];j++) fprintf(opt.dest,"     ");
	   fprintf(opt.dest,"[ %s ]",parm->aff[i]);
	   break;
	 case D_SUFFIX:
	   fprintf(opt.dest," %s",parm->aff[i]);
	   break;
	 }
    } else {
	 /* dont have the right to display, sniff... */
	 if (parm->type_aff[i]==D_LABEL) {
	   j=strlen(parm->aff[i]);
	   if (strncmp(opt.disp_label,parm->aff[i],(len<j)?len:i)==0) have_to_display=YES;

	   if ((!opt.sum) || (have_to_display==YES)) {
	     fprintf(opt.dest,"\n");
	     for (j=0;j<parm->indenttab[i]-1;j++) fprintf(opt.dest,"     ");
	     if ((i>0) && (parm->indenttab[i]>parm->indenttab[i-1])) fprintf(opt.dest,"+----");
	     if ((i>0) && (parm->indenttab[i]==parm->indenttab[i-1])) fprintf(opt.dest,"     ");
	     fprintf(opt.dest,"+-- %s --",parm->aff[i]);
	   }
	 } 
	 
    }

  }

  /*** the end ***/
  if (have_to_display) {
    fprintf(opt.dest,"\n\n");
  }
  /*** ------- ***/


}

