/* tcp-msglogger - tcpclient.c, by pheisar@ccl.pt - read tcpserver.c */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

extern int h_errno;

#define USAGE "usage: %s <hostname>\n", argv[0]
#define PORT 31337
#define MAXSIZE 1024

struct sockaddr_in s_addr;
struct hostent *host;

void main(int argc, char **argv)
{
	int sfd, n;
	char mesg[MAXSIZE];

	if(argc < 2) {
		printf(USAGE);
		exit(1);
	}

	memset((char *)&s_addr, 0, sizeof(s_addr));
	s_addr.sin_family = AF_INET;
	s_addr.sin_port = htons(PORT);
	if( (s_addr.sin_addr.s_addr = inet_addr(argv[1])) != 0xffffffff) {
	} else {
		if( (host = gethostbyname(argv[1])) == NULL) {
			herror("gethostbyname()");
			exit(1);
		}
		memcpy((char *)&s_addr.sin_addr, host->h_addr, host->h_length);
	}

	if( (sfd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1) {
		perror("socket()");
		exit(1);
	}

	if(connect(sfd, (struct sockaddr *)&s_addr, sizeof(s_addr)) < 0) {
		perror("connect()");
		exit(1);
	}	
	
	printf("mesg: ");
	fgets(mesg, MAXSIZE, stdin);
	mesg[strlen(mesg)-1] = '\0';

	if( (n = send(sfd, mesg, sizeof(mesg), 0)) < 0) {
		perror("send()");
		exit(1);
	}

	close(sfd);
}				
