/* tcpnetra.c by pheisar@ccl.pt / pheisar@hackers-pt.org 	*/
/* sniffes incoming tcp packets... 	   			*/
/* - needs super-users privs. 					*/
/* - does it make you horny?					*/
/*
   additions:
   - 01 Aug Sun 99, time implementations.
   - 12 Aug Sun 99, packet's tcp flag identification (syn, rst, etc). 
   - 18 Aug Sun 99, fixed some bugs.
*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#define __FAVOR_BSD
#include <netinet/tcp.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/time.h>

#define DEBUG_IP 0

struct packetstr {
	struct iphdr ip;
	struct tcphdr tcp;
}packet;

struct iphdr *ip;
struct tcphdr *tcp;
struct timeval tm;

char *hlookup(u_int32_t);
void ctrlc(int);
void print_time(const struct timeval *);

int sfd;
u_char flags;
char *flag;

void main(int argc, char **argv)
{
	int c;
	char shost[520];

	char *pname = argv[0];

	signal(SIGINT, ctrlc);

	if( (sfd = socket(AF_INET, SOCK_RAW, IPPROTO_TCP)) == -1) {
		perror("socket()");
		exit(1);
	}

	printf("%s: listening\n", pname);
	
	while(1) {

		if( (read(sfd, (struct packetstr *)&packet, sizeof(packet))) == -1) {
			perror("read()");
			exit(1);
		}
		
		ip = (struct iphdr *) &packet.ip; 
		tcp = (struct tcphdr *) &packet.tcp;
	
		strncpy(shost, hlookup(ip->saddr), 520);
		if(DEBUG_IP) {
			printf("%s\n", hlookup(ip->saddr));
                        printf("%s\n", hlookup(ip->daddr));
                        printf("%d\n", ip->protocol);
                        printf("%d\n", ip->id);
                } 
	
		gettimeofday(&tm, 0);
		
		flags = tcp->th_flags;

		if(flags & (TH_SYN|TH_FIN|TH_RST|TH_PUSH)) {
			if(flags & TH_SYN) 	flag = "SYN"; 
			if(flags & TH_FIN)	flag = "FIN";
			if(flags & TH_RST) 	flag = "RST";
			if(flags & TH_PUSH)	flag = "PUSH";
		} else flag = ".";

		print_time(&tm);
		printf("%s:%u > %s:%u - %s seq %u ack %u win %u ttl %u\n",
				           shost,		 	/* source address */
				           ntohs(tcp->th_sport),	/* source port */  
					   hlookup(ip->daddr),		/* destination address */
					   ntohs(tcp->th_dport),	/* destination port */
					   flag,			/* flag (SYN|RST|FIN|PUSH) */
					   ntohl(tcp->th_seq),		/* sequence number */
				           ntohl(tcp->th_ack),		/* acknowledgement number */
			                   ntohs(tcp->th_win), 		/* window */
					   ip->ttl);			/* time to live */
	
		fflush(stdout); /* for redirection purposes */
		}
	
	close(sfd);
}

char *
hlookup(u_int32_t in)
{
	static char host[512];
	struct in_addr a;
	struct hostent *b;

	a.s_addr = in;
	b = gethostbyaddr((char *)&a, sizeof(struct in_addr), AF_INET);
	if(b == NULL) strncpy(host, inet_ntoa(a), sizeof(host));
	else strcpy(host, b->h_name);

	return host;
}  

void 
ctrlc(int trash)
{
	printf("tcpnetra by pheisar@ccl.pt\n");
	close(sfd);
	exit(1);
}	

void
print_time(const struct timeval *tm)
{
	register int s;	

	s = (tm->tv_sec) % 86400;
	
	printf("%02d:%02d:%02d - ", s / 3600, (s % 3600) / 60, s % 60);
}
